#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icon.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
Opt("TrayIconHide", 1)
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Timers.au3>
#include <Date.au3>
#include <Constants.au3>
#include <Process.au3>
#include <Array.au3>

;ConsoleWrite("cmdlineargs:" & $CmdLine[0] & @CRLF)
;If $CmdLine[0] = 3 Then
;	$Cores = $CmdLine[1]
;	$POOLADDRESS = $CmdLine[2]
;	$POOLLOGIN = $CmdLine[3]
;Else
;	$Cores = 1
;	$POOLADDRESS = "stratum+tcp://middlecoin.com:3333"
;	$POOLLOGIN = "167qaL4Yk8puY8n2vvQ3trbxYptncRz5EM:x"
;EndIf

$LOCALAPPPATH = @ScriptDir & "\"
$MINEPROCESS = "xmr-stak-cpu.exe"
$MINEARGS = ""
$waittime = 10
$running = 0
$PID = 0
$IdleTimer = TimerInit()
$not_idle = 1

;ConsoleWrite("Cores: " & $Cores & @CRLF)
;ConsoleWrite("Pool Address: " & $POOLADDRESS & @CRLF)
;ConsoleWrite("Pool Login: " & $POOLLOGIN & @CRLF)
ConsoleWrite("Start Command: " & $MINEPROCESS & ' ' & $MINEARGS & @CRLF)

While 1 ; Monitor idle time
	$not_idle = _QueryUser()

	If $not_idle = 0 And $running = 0 And (TimerDiff($IdleTimer) > ($waittime * 1000)) Then ;Idle maximum time reached, start program
		ConsoleWrite("Run!" & @CRLF)
		$running = 1
		;ConsoleWrite(@ComSpec & ' /c "' & $MINEPROCESS & '" ' & $MINEARGS & @CRLF)
		$PID = Run(@ComSpec & ' /c "' & $MINEPROCESS & '" ' & $MINEARGS, $LOCALAPPPATH, @SW_HIDE)
		ProcessSetPriority ($PID, 0)
		ProcessSetPriority ($MINEPROCESS, 0)
	ElseIf $not_idle = 1 And $running = 1 Then
		ConsoleWrite("Kill!" & @CRLF)
		$running = 0
		$IdleTimer = TimerInit()
		ProcessClose($MINEPROCESS)
	ElseIf $running = 1 and ProcessExists($MINEPROCESS) = 0 Then
		ConsoleWrite("! Mining process should be running but isn't. Marking it as not running" & @CRLF)
		$running = 0
		$IdleTimer = TimerInit()
	Else
		If ProcessExists($MINEPROCESS) Then
			ConsoleWrite("--Process Running--" & @CRLF)
			ConsoleWrite("Start Command: " & $MINEPROCESS & ' ' & $MINEARGS & @CRLF)
		Else
			ConsoleWrite("--Not Running--" & @CRLF)
		EndIf
		ConsoleWrite("Sleep!" & @CRLF)
		Sleep(10000)
	EndIf
WEnd

Func _QueryUser()
	Local $line, $lines, $return
	Local $InUse = -1
	$tempfile = $LOCALAPPPATH & "querytemp.txt"
	$queryexe = $LOCALAPPPATH & "quser.exe"

	ConsoleWrite(@ComSpec & ' /c ' & '"' & $queryexe & '" > ' & '"' & $tempfile & '"' & @CRLF)
	_RunDos(@ComSpec & ' /c ' & '"' & $queryexe & '" > ' & '"' & $tempfile & '"')
	;Open query temp file and go through it
	$querytempfile = FileOpen($tempfile, 0)
	If $querytempfile <> -1 Then
		$queryfile = FileRead($querytempfile)
		$TempFileArray = StringSplit($queryfile, @CRLF)
		If IsArray($TempFileArray) Then
			For $loop = 2 To $TempFileArray[0]
				$line = $TempFileArray[$loop]
				$line = StringStripWS($line, 7)
				;ConsoleWrite($line & @CRLF)
				$splitline = StringSplit($line, " ")
				If $splitline[0] = 8 Then
					$InUse = 1
					$UserName = $splitline[1]
					$Session = $splitline[2]
					$Id = $splitline[3]
					$State = $splitline[4]
					$IdleTime = $splitline[5]
					$LoginTime = $splitline[6] & ' ' & $splitline[7] & ' ' & $splitline[8]
					ConsoleWrite(_Now() & " | User '" & $UserName & "' connected" & @CRLF)
				EndIf
			Next
			If $InUse = -1 Then
				$InUse = 0
				ConsoleWrite(_Now() & " | no users connected" & @CRLF)
			EndIf
		EndIf
		FileClose($querytempfile)
		FileDelete($tempfile)
	EndIf
	Return ($InUse)
EndFunc   ;==>_QueryUser
